@echo off

set hex_file="%~1"
set progflags=-c SWD UR
set hotprogflags=-c SWD HOTPLUG

set progsuffix=\STMicroelectronics\STM32 ST-LINK Utility\ST-LINK Utility\ST-LINK_CLI.exe

set progStd="%ProgramFiles%%progsuffix%"
set progX86="%ProgramFiles(x86)%%progsuffix%"
set progW6432="%ProgramW6432%%progsuffix%"

if exist %progStd% goto use_progfiles
if exist %progX86% goto use_progfiles_x86
if exist %progW6432% goto use_prog_w6432
echo.
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo -----------------------------------------
echo --- Could not find ST-LINK_CLI
echo --- in any program files dir
echo --- (%progStd%)
echo --- (%progX86%)
echo --- (%progW6432%)
echo -----------------------------------------
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo.
echo.
pause
goto exit

:use_progfiles
set prog=%progStd%
goto first_start

:use_progfiles_x86
set prog=%progX86%
goto first_start

:use_prog_w6432
set prog=%progW6432%
goto first_start

if exist %hex_file% goto first_start
echo.
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo -----------------------------------------
echo --- Could not find hex-file
echo --- (%hex_file%)
echo -----------------------------------------
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo.
echo.
pause
goto exit

:first_start
echo -----------------------------------------
echo --- You are about to program ESLM10 Production Parameters
echo --- with program:
echo --- (%hex_file%)
echo ---
echo --- Press enter to start
echo -----------------------------------------
pause

:start
echo.
echo.
echo.
echo.

echo -----------------------------------------
echo Read option bytes
%prog% %progflags% -rOB
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------

echo -----------------------------------------
echo Clear code protection bit
%prog% %progflags% -OB RDP=0
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------

echo -----------------------------------------
echo Sector 1 erase
%prog% %progflags% -SE 1
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------

echo -----------------------------------------
echo Program and verify flash
%prog% %progflags% -P %hex_file% -V after_programming
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------

rem echo -----------------------------------------
rem echo Set code protection bit
rem %prog% %progflags% -OB RDP=1
rem IF NOT %ERRORLEVEL% ==0 goto error
rem echo Done
rem echo -----------------------------------------

echo -----------------------------------------
echo Read option bytes
%prog% %progflags% -rOB
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------

echo -----------------------------------------
echo Reset device
%prog% %progflags% -Rst
IF NOT %ERRORLEVEL% ==0 goto error
echo Done
echo -----------------------------------------



echo.
echo.
echo -----------------------------------------
echo --- All programming done OK
echo ---
echo --- Press enter to program next chip
echo --- Or press CTRL+C to abort this script
echo -----------------------------------------
pause
goto start

:error
echo.
echo.
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
echo -----------------------------------------
echo --- Programming failed
echo ---
echo --- Press enter to retry
echo -----------------------------------------
echo ERROR ERROR ERROR ERROR ERROR ERROR ERROR
pause
goto start

:exit
pause
